package org.mikgul;

import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import java.io.IOException;

public class WeatherResponse {
    private static final String API_KEY = "c1a110184e10999b88cc360d8580ef57";
    private static final String API_URL = "https://api.openweathermap.org/data/2.5/weather";

    private int statusCode;
    private String responseBody;

    public WeatherResponse() {}

    public int getStatusCode() {
        return statusCode;
    }

    public String getBody() {
        return responseBody;
    }

    public void setStatusCode(int statusCode) {
        this.statusCode = statusCode;
    }

    public void setResponseBody(String responseBody) {
        this.responseBody = responseBody;
    }

    public WeatherResponse sendWeatherRequest(Coordinates coordinates) {
        String apiUrl = String.format("%s?lat=%s&lon=%s&appid=%s&lang=pl&units=metric",
                API_URL, coordinates.latitude(), coordinates.longitude(), API_KEY);

        try (CloseableHttpClient httpclient = HttpClients.createDefault()) {
            HttpGet request = new HttpGet(apiUrl);
            try (CloseableHttpResponse response = httpclient.execute(request)) {
                HttpEntity entity = response.getEntity();
                setStatusCode(response.getStatusLine().getStatusCode());
                setResponseBody(EntityUtils.toString(entity));
            }
        } catch (IOException e) {
            throw new RuntimeException("Blad przy wysylaniu zapytania do API: ", e);
        }

        return this;
    }
}
